<?php
/*
 * Created: 		15.9.2005 
 * Author:	 		Gimli2 
 * Description:	
 * It's freeware smart utility for making new font files for use with FPDF
 * library for PHP in selected codepage. You simple select which font from WIN
 * directory will be used and everything other is automatic. Finally you only
 * copy 2 files for use in FPDF (*.z a *.php). This is only WIN version, but you
 * can change path to fonts, win binary program for getting font metrics. And it
 * should be working. You need to have enabled PHP function exec().
 */
  
  $fontdir = $WINDIR . "/fonts/";
  $tempdir = './temp/';
  
  // nactem si dostupne TTF fonty do pole
  $pf = array();
  foreach (glob($fontdir.'*.ttf') as $key=>$value) {
  	$pf[] = '<option value="'.$value.'">'.substr(basename($value),0,-4).'</option>'."\n";
  }  
  // nastem si dostupne MAP soubory s kodavacimi strankami
  $cp = array();
  foreach (glob('*.map') as $key=>$value) {
  	$ccp = substr(basename($value),0,-4);
  	if ($ccp == 'cp1250') {
  		$sel = ' selected'; 
  	} else {
  		$sel = '';
  	}
  	$cp[] = '<option value="'.$value.'"'.$sel.'>'.$ccp.'</option>'."\n";
  }  
  echo '<form action="'.basename($PHP_SELF).'" method="POST">';
  echo '<input type="hidden" name="akce" value="zpracuj">'; 
  // vyrobime z pole select
  echo 'Dostupn TTF fonty: <select name="srcfontfile">';
  echo implode('', $pf);
  echo '</select> (zvol njak pro pevod do formtu pro pouit v FPDF)<br />';
  echo 'Dostupn kdovac tabulky: <select name="codepage">';
  echo implode('', $cp);
  echo '</select><br />';
  echo '<input type="submit" value="Konvertuj">';
  echo '</form>'."\n";

  if ($_POST['akce'] == 'zpracuj' && isset($_POST['srcfontfile'])) {
    // zdroj fontu
    $srcfontfile = $_POST['srcfontfile'];
    // kodovaci tabulka
    $codepage = $_POST['codepage'];
    // samotny nazev fontu
    $purefname = strtolower(substr(basename($srcfontfile),0,-4));
    
    // ziskani metriky fontu
    $batch = 'ttf2pt1 -b -L '.$codepage.' '.$srcfontfile.' '.$tempdir.$purefname;
    echo 'Ziskavam metriku fontu ('.$batch.')<br>';
    exec($batch);
    
    // nacteni funkci pro vygenerovani souboru pro pouziti v FPDF
    include 'makefont.php';
    
    // konverze do onech souboru
    echo 'Konvertuji font...<br>';
    MakeFont($tempdir.$purefname.'.pfb', $tempdir.$purefname.'.afm' , substr($codepage,0,-4));
    
    // zameteme po sobe
    echo 'Mazu pomocne soubory<br>';
    @unlink($tempdir.$purefname.'.pfb');
    @unlink($tempdir.$purefname.'.afm');
    
    echo '<strong>Zkopirujte si nyni hotove soubory '.$purefname.'.z a '.$purefname.'.php z adresare '.$tempdir.' do adresare s fonty pro FPDF</strong><br />';
  }
?>
